      
      subroutine fff(s,u,up)
      implicit real*8 (a-h,o-z)
c     ODE system for geodesics
      
c     subr/fff  status :     10 October 1989

c     J. G. Dworski
      
c     H a n d l i n g :
c     =================
c     rmer [km] is the meridional radius of curvature of the
c     earth's oblate spheroid at latitude /glat; rpve [km] is
c     the radius of curvature in the plane of the "prime vertical",
c     at the same latitude.
      
c     sinl,cosl are sine and cosine of latitude. /geordG/ returns
c     the nontrivial true ellipsoidal parametrization, and
c     is accompanied by a nearly trivial version /geordS/ that
c     returns the corresponding information on a sphere of equal
c     area to the earth's ellipsoid.
      
c     s      =  path-length  [km]
c     u(1)   =  latitude     [rad]
c     u(2)   =  longitude    [rad]
c     u(3)   =  azimuth      [rad]
c     up(1)  =  du(1)/ds     [rad/km]
c     up(2)  =  du(2)/ds     [rad/km]
c     up(3)  =  du(3)/ds     [rad/km]
      
      
c     ------------------------------------------------------------
c     changes:
c     changed "double precision" to "real*8"  (craig friesen 7/8/92)
c     ------------------------------------------------------------
      
      parameter( tor=1.745329252d-02 )
      parameter( n=3,pi=3.1415926535d0 )
      real*8       s,u(n),up(n)
      
      glat    =  dble(u(1))
c     ****************************************
      call geordG( glat,sinl,cosl,rmer,rpve )
c     ****************************************
      cosa    =  cos(u(3))
      sina    =  sin(u(3))
      
      up(1)   =  cosa /     rmer
      up(2)   =  sina /   ( rpve*cosl )
      up(3)   = (sinl/cosl)/rpve*sina
      
      return
      end
      
