
      subroutine geordG( glat,sinl,cosl,rmer,rpve )
      implicit real*8 (a-h,o-z)

c     principal radii of curvature on earth's oblate spheroid
c     (ellipsoid) at geodesic latitude, glat,
c     and - no longer of interest - estimate of the azimuth for
c     a geodesic having the Clairaut invariant fk0.

c     subr/DgeordG.f     status  :    12 June 1990

c     J. G. Dworski

c     H a n d l i n g :
c     =================
c     Parameters for the ellipsoid are from the Department of Defense
c     World Geodetic System WGS 84, and are used throughout.
c     Latitude is negative in the Southern Hemisphere.

c     I n p u t    (real*8) :
c     -----------
c-     fk0      =  Clairaut's invariant for the particular geodesic [km],
c     glat     =  geodesic latitude    [rad],

c     O u t p u t  (real*8) :
c     -------------
c     sinl     =  sine   of the latitude [-],
c     cosl     =  cosine of the latitude [-],
c     rmer     =  meridional radius of curvature  [km],
c     rpve     =  radius of curvature in plane of "prime vertical" [km],
c-     azim     =  ESTIMATE of the azimuth [rad] of the geodesic w/ fk0.


c     ------------------------------------------------------------
c     changes:
c       changed "double precision" to "real*8"  (craig friesen 7/8/92)
c     ------------------------------------------------------------


      parameter( torad=1.745329252d-02 )
      parameter( a=6.378137d+03,e2=6.694379990d-03,ep2=9.933056200d-01)
      parameter(r0=6.371005d+03)

      sinl   = sin(glat)
      cosl   = sqrt(1.d0-sinl**2)
      w2     = 1.d0 - e2*sinl**2
      w1     = sqrt(w2)
      w3     = w1**3
      rmer   = a * ep2 / w3
      rpve   = a / w1
c-      azim   = asin(fk0/(rpve*cosl))

      return
      end
