      program grange

c     this program is an interface for gdist.f.  (get the numbers, 
c     check that they're okay, make the call, and print 'em out.) 

c     gdist.f is a version of George Dworski's iGEOD.f program
c     that calculates geodesics.  

c     This program takes the (input) parameters off the command line
c     (see Usage message below for syntax) and puts the output on the
c     standard output.

c     units used are meters, degrees.

c     6/30/92 craig friesen
c===============================================================

      
      real*8 dlaA,dloA,dlaB,dloB,range,azis,azir
      character*100 strTemp

      print *
c     get stuff off the command line, verify that it's okay

      m = iargc()
      if (m .ne. 4) then
         write (0,*)'grange: wrong number of arguments.'
         write (0,*)'Usage: grange lat(origin) long(origin)',
     *              ' lat(destination) long(destination)'
         STOP
      endif

      call getarg(1, strTemp)
      read (strTemp, *) dlaA
      if (abs(dlaA).gt.90.d0) then
         write (0,*)'grange: ERROR : latitude ',dlaA,' is out of bounds'
         STOP
      endif

      call getarg(2, strTemp)
      read (strTemp, *) dloA
      if (dloA.lt.-180.d0 .or. dloA.gt.360.d0) then
         write (0,*)'grange: ERROR : longitude ',dloA,
     *        ' is out of bounds'
         STOP
      endif
      
      call getarg(3, strTemp)
      read (strTemp, *) dlaB
      if (abs(dlaB).gt.90.d0) then
        write (0,*)'grange: ERROR : latitude ',dlaB,' is out of bounds'
        STOP
      endif

      call getarg(4, strTemp)
      read (strTemp, *) dloB
      if (dloB.lt.-180.d0 .or. dloB.gt.360.d0) then
        write (0,*)'grange: ERROR : longitude ',dloB,' is out of bounds'
        STOP
      endif


      print *,'source lat       [deg]:',dlaA
      print *,'source long      [deg]:',dloA
      print *,'receiver lat     [deg]:',dlaB
      print *,'receiver long    [deg]:',dloB
      print *,' '

c     ************************************************
      call gdist(dlaA,dloA,dlaB,dloB,azis,azir,range)
c     ************************************************
      
      pi=3.141592653589d0
      r2d = 360.d0 / (2.d0*pi)
      print*,'range              [m]:',range
      print*,'source azimuthh  [deg]:',azis*r2d
      print*,'receiver azimuth [deg]:',azir*r2d
      print*
      STOP
      end
      
