      program gshoot

c     this program is an interface for sgshoot.f (get the numbers, 
c     check that they're okay, make the call, and print 'em out.) 
c     sgshoot.f is a version of George Dworski's ddr18.f program
c     that calculates points along geodesics.  

c     This program takes the (input) parameters off the command line
c     (see Usage message below for syntax), calls sgshoot and puts
c     the output to the standard output.

c     6/30/92 craig friesen
c     ==========================================================

      implicit real*8 (a-h,o-z)
      real*8 lat,long,azi,inc,range
      character*40 strTemp
      real*8 ranges(5000),lats(5000),longs(5000),azis(5000)
      integer count

 510  format(f12.2,4f12.6)

        m = iargc()
        if (m .ne. 5) then 
           write (0,*)'wrong number of arguments.'
           write (0,*)'Usage: gshoot lat(origin) long(origin)',
     *          ' azimuth(origin) increment-range  range'
           write (0,*)
           STOP
        endif

        call getarg(1, strTemp)
        read (strTemp, *) lat

        call getarg(2, strTemp)
        read (strTemp, *) long

        call getarg(3, strTemp)
        read (strTemp, *) azi

        call getarg(4, strTemp)
        read (strTemp, *) inc

        call getarg(5, strTemp)
        read (strTemp, *) range
        if (inc .lt. 5.d-1) then
           write (0,*)'increment too small'
           write (0,*)
           STOP
        endif

        if ((range/inc) .gt. 4999) then 
           write (0,*)'too many iterations: either chose larger'
           write (0,*) '  increment-range, smaller range,'
           write (0,*)'   or re-dimension arrays in gshoot.f'
           write (0,*)
           STOP
        endif
           
c     *************************************
      call sgshoot(long,lat,azi,inc,range,ranges,lats,longs,azis)
c     *************************************

c     print 'em
      
c      print*,'     RANGE        LAT         LON         AZI'
c      print*,'      [m]        [deg]       [deg]       [deg]'

      do 111, count = 1,(range/inc)+1
         print 510, ranges(count),lats(count),
     *        longs(count),azis(count)
 111  continue
      if (ranges(count) .gt. 0) then
         if (abs(ranges(count) - ranges(count-1)) .gt. 1.d-5) then
            print 510, ranges(count),lats(count),
     *           longs(count),azis(count)
         endif       
      endif
      end

