
      program rgrangeinc

c     this program is an interface for the routines rgdist.f and rgshoot.f
c     (get the numbers, check that they're okay, make the call, and print 'em
c     out.) which are subroutine versions of George Dworski's iGEOD.f and 
c     ddr18.f programs.

c     This program takes the (input) parameters off the command line
c     (see Usage message below for syntax)

c     for information on how the refracted geodesic is calculated, 
c     look in rgdist.f and rgshoot.f

c     6/30/92 craig friesen
c     10/21/94 Shaun Leach
c===============================================================

      real*8 dlaA,dloA,dlaB,dloB,range,azis,azir,inc
      character*100 strTemp
      real*8 ranges(10000),lats(10000),longs(10000),azips(10000)
      integer count

 510  format(f12.2,4f12.6)

      pi = 4.d0*atan(1.d0)
      CANGLE = 2.D0*PI/360.D0



      m = iargc()
      if (m .ne. 5) then
         write (0,*)'wrong number of arguments.'
         write (0,*)'Usage: rgrangeinc lat(origin) long(origin) '
         write (0,*)'           lat(destination) long(destination)'
         write (0,*)'           range-increment'
         write (0,*)
         STOP
      endif

      call getarg(1, strTemp)
      read (strTemp, *) dlaA
      if (abs(dlaA).gt.90.d0) then
         write (0,*)' ERROR : latitude ',dlaA,' is out of bounds'
         STOP
      endif

      call getarg(2, strTemp)
      read (strTemp, *) dloA
      if (dloA.lt.-180.d0 .or. dloA.gt.360.d0) then
         write (0,*)'ERROR : longitude ',dloA,' is out of bounds'
         STOP
      endif
      
      call getarg(3, strTemp)
      read (strTemp, *) dlaB
      if (abs(dlaB).gt.90.d0) then
         write (0,*)' ERROR : latitude ',dlaB,' is out of bounds'
         STOP
      endif

      call getarg(4, strTemp)
      read (strTemp, *) dloB
      if (dloB.lt.-180.d0 .or. dloB.gt.360.d0) then
        write (0,*)' ERROR : longitude ',dloB,' is out of bounds'
        STOP
      endif

      call getarg(5, strTemp)
      read (strTemp, *) inc
      if (inc .lt. 5.d-1) then
         write (0,*)'increment too small'
         write (0,*)
         STOP
      endif

      
c     i guess we don't need to print out what we've just entered in,
c     but if we want this later:

c      print*,'source lat       [deg]:',dlaA
c      print*,'source long      [deg]:',dloA
c      print*,'receiver lat     [deg]:',dlaB
c      print*,'receiver long    [deg]:',dloB

c      print*


c     ************************************************
      call rgdist(dlaA,dloA,dlaB,dloB,azis,azir,range)
c     ************************************************

      azis = azis /cangle

c     *************************************
      call srgshoot(dloA,dlaA,azis,inc,range,ranges,lats,longs,azips)
c     *************************************

c     removed header:
      
c      print*,'     RANGE        LAT         LON         AZI'
c      print*,'      [m]        [deg]       [deg]       [deg]'

      do 111, count = 1,(range/inc)+1
         print 510, ranges(count),lats(count),
     *        longs(count),azips(count)
 111  continue
      if (ranges(count) .gt. 0) then
         if (abs(ranges(count) - ranges(count-1)) .gt. 1.d-5) then
            print 510, ranges(count),lats(count),
     *           longs(count),azips(count)
         endif       
      endif




c      print *,dlaA,dloA,azis,inc,range
      end
